## mingw-w64-qt6-quick3d-6.7.2-1.src.tar.zst

=== src/glslparser/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_internal_add_module(Quick3DGlslParserPrivate
    INTERNAL_MODULE
    DEFINES
        QT_BUILD_QUICK3DGLSLPARSER_PRIVATE_LIB
    SOURCES
        glsl_p.h
        glslast.cpp glslast_p.h
        glslastdump.cpp glslastdump_p.h
        glslastvisitor.cpp glslastvisitor_p.h
        glslengine.cpp glslengine_p.h
        glslkeywords.cpp
        glsllexer.cpp glsllexer_p.h
        glslmemorypool.cpp glslmemorypool_p.h
        glslparser.cpp glslparser_p.h
        glslparsertable.cpp glslparsertable_p.h
        glslsemantic.cpp glslsemantic_p.h
        glslsymbol.cpp glslsymbol_p.h
        glslsymbols.cpp glslsymbols_p.h
        glsltype.cpp glsltype_p.h
        glsltypes.cpp glsltypes_p.h
    DEFINES
        QT_NO_CAST_FROM_ASCII
    PUBLIC_LIBRARIES
        Qt::Core
    GENERATE_CPP_EXPORTS
    GENERATE_PRIVATE_CPP_EXPORTS
)

=== tests/auto/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from auto.pro.
# exclude for CI build
add_subdirectory(quick3d_visual)
if(QT_BUILD_MINIMAL_STATIC_TESTS)
    return()
endif()
#add_subdirectory(cmake) # special case
if(NOT INTEGRITY)
    add_subdirectory(quick3d)
endif()
add_subdirectory(quick3d_particles)
add_subdirectory(utils)
add_subdirectory(tools)
if((android_app OR NOT ANDROID) AND (android_app OR NOT INTEGRITY) AND (NOT ANDROID OR NOT CMAKE_CROSSCOMPILING) AND (NOT ANDROID OR NOT WASM) AND (NOT CMAKE_CROSSCOMPILING OR NOT INTEGRITY) AND (NOT INTEGRITY OR NOT WASM))
    add_subdirectory(assetimport)
endif()

=== examples/quick3d/customgeometry/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause

cmake_minimum_required(VERSION 3.16)
project(customgeometry LANGUAGES CXX)

set(CMAKE_AUTOMOC ON)

find_package(Qt6 REQUIRED COMPONENTS Core Gui Quick Quick3D)

qt_add_executable(customgeometry
    main.cpp
)

set_target_properties(customgeometry PROPERTIES
    WIN32_EXECUTABLE TRUE
    MACOSX_BUNDLE TRUE
)

target_link_libraries(customgeometry PUBLIC
    Qt::Core
    Qt::Gui
    Qt::Quick
    Qt::Quick3D
)

qt_add_qml_module(customgeometry
    URI CustomGeometryExample
    VERSION 1.0
    QML_FILES
        Main.qml
        TorusMesh.qml
    SOURCES
        examplegeometry.cpp examplegeometry.h
    RESOURCES qt_logo_rect.png
    RESOURCE_PREFIX "/qt/qml"
    IMPORTS
        QtQuick3D
)

install(TARGETS customgeometry
    BUNDLE  DESTINATION .
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

qt_generate_deploy_qml_app_script(
    TARGET customgeometry
    OUTPUT_SCRIPT deploy_script
    MACOS_BUNDLE_POST_BUILD
    NO_UNSUPPORTED_PLATFORM_ERROR
    DEPLOY_USER_QML_MODULES_ON_UNSUPPORTED_PLATFORM
)
install(SCRIPT ${deploy_script})

=== examples/quick3d/lights/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause

cmake_minimum_required(VERSION 3.16)
project(lights LANGUAGES CXX)

set(CMAKE_AUTOMOC ON)

find_package(Qt6 REQUIRED COMPONENTS Core Gui Quick Quick3D)

qt_add_executable(lights
    main.cpp
)

set_target_properties(lights PROPERTIES
    WIN32_EXECUTABLE TRUE
    MACOSX_BUNDLE TRUE
)

target_link_libraries(lights PUBLIC
    Qt::Core
    Qt::Gui
    Qt::Quick
    Qt::Quick3D
)

qt_add_qml_module(lights
    URI Example
    VERSION 1.0
    QML_FILES
        RotatingTeaPot.qml
        SettingsDrawer.qml
        main.qml
    RESOURCES
        custom.vert
        teapot.mesh
        icon_settings.png
        icon_settings@2x.png
        icon_settings@3x.png
        icon_settings@4x.png
        qtquickcontrols2.conf
        +windows/qtquickcontrols2.conf
    NO_RESOURCE_TARGET_PATH
)

install(TARGETS lights
    BUNDLE  DESTINATION .
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

qt_generate_deploy_qml_app_script(
    TARGET lights
    OUTPUT_SCRIPT deploy_script
    MACOS_BUNDLE_POST_BUILD
    NO_UNSUPPORTED_PLATFORM_ERROR
    DEPLOY_USER_QML_MODULES_ON_UNSUPPORTED_PLATFORM
)
install(SCRIPT ${deploy_script})

=== src/helpers/impl/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_internal_add_qml_module(Quick3DHelpersImpl
    URI "QtQuick3D.Helpers.impl"
    VERSION "${PROJECT_VERSION}"
    CLASS_NAME QtQuick3DHelpersImplPlugin
    PLUGIN_TARGET qtquick3dhelpersimplplugin
    NO_PLUGIN_OPTIONAL
    DEPENDENCIES
        QtQuick3D/auto
    SOURCES
        sceneeffects.cpp sceneeffects_p.h
        qquick3drenderstatsmeshesmodel_p.h qquick3drenderstatsmeshesmodel.cpp
        qquick3drenderstatstexturesmodel_p.h qquick3drenderstatstexturesmodel.cpp
        qquick3drenderstatspassesmodel_p.h qquick3drenderstatspassesmodel.cpp
    QML_FILES
        DepthOfFieldBlur.qml
        SceneEffect.qml
        LightmapperOutputWindow.qml
    LIBRARIES
        Qt::Qml
        Qt::Quick
        Qt::Quick3DPrivate
)

qt_internal_add_resource(Quick3DHelpersImpl "helpersimpl_resources"
    PREFIX
        "/qtquick3d_helpers"
    FILES
        shaders/lensflareblurhorizontal.vert
        shaders/lensflareblurvertical.vert
        shaders/lensflaredownsample.frag
        shaders/lensflarefeatures.frag
        shaders/lensflaregaussianblur.frag
        shaders/tonemapper.frag
        shaders/depthoffieldblur.frag
        shaders/depthoffieldblur.vert
        shaders/downsample.frag
        shaders/downsample.vert
        shaders/glowhorizontalblur.frag
        shaders/glowverticalblur.frag

        images/lens_dirt_default.jpeg
        images/noiseTexture.png
        images/gradientTexture.png

        luts/identity.png
)

=== examples/quick3d/virtualassistant/imports/Constants/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause

set_source_files_properties(Constants.qml
    PROPERTIES
        QT_QML_SINGLETON_TYPE true
)

qt_add_library(Constants STATIC)
qt_add_qml_module(Constants
    URI "VirtualAssistant.Constants"
    VERSION 1.0
    RESOURCE_PREFIX "/qt/qml"
    QML_FILES
        Constants.qml
)

target_link_libraries(Constants
    PRIVATE
        Qt${QT_VERSION_MAJOR}::Quick
)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=qt6-quick3d
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-debug")
_qtver=6.7.2
pkgver=${_qtver/-/}
pkgrel=1
pkgdesc='Qt module and API for defining 3D content in Qt Quick (mingw-w64)'
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.qt.io'
msys2_repository_url="https://code.qt.io/cgit/qt/qtquick3d.git"
msys2_references=(
  'archlinux: qt6-quick3d'
  "cpe: cpe:/a:qt:qt"
)
license=('spdx:GPL-3.0-only WITH Qt-GPL-exception-1.0 AND LGPL-3.0-only AND BSD-3-Clause AND GFDL-1.3-no-invariants-only AND GPL-2.0-only')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-assimp"
             "${MINGW_PACKAGE_PREFIX}-vulkan-headers"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-qt6-shadertools"
             "${MINGW_PACKAGE_PREFIX}-qt6-quicktimeline"
             "rsync")
_pkgfn="${_realname/6-/}-everywhere-src-${_qtver}"
source=("https://download.qt.io/official_releases/qt/${pkgver%.*}/${_qtver}/submodules/${_pkgfn}.tar.xz"
        001-appending-qt6-to-remove-qt5-conflict.patch)
sha256sums=('bb8ff9aec6da2e2d3b3986cc859333a98b2f3d4bbe564c5733e8f1a089d15270'
            '211bb1f042bf9c0ddedb15b0e3d62b94e3b247dc96294fd92f4d8035784f1c7d')

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd $srcdir/${_pkgfn}

  apply_patch_with_msg \
    001-appending-qt6-to-remove-qt5-conflict.patch
}

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    --log-level=STATUS \
    -GNinja \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    ../${_pkgfn}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package_qt6-quick3d() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-declarative"
           "${MINGW_PACKAGE_PREFIX}-qt6-shadertools")
  optdepends=("${MINGW_PACKAGE_PREFIX}-qt6-quicktimeline"
              "${MINGW_PACKAGE_PREFIX}-assimp")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6")

  DESTDIR=${pkgdir} ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}

  # Seperate debug-info files
  rsync -armR --remove-source-files --include="*/" --include="*.debug" --exclude="*" --prune-empty-dirs ${pkgdir}/.${MINGW_PREFIX} ${srcdir}/${MSYSTEM}-debug/

  install -d "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
  install -Dm644 $_pkgfn/LICENSES/* -t "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
}

package_qt6-quick3d-debug() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-declarative-debug"
           "${MINGW_PACKAGE_PREFIX}-qt6-shadertools-debug"
           "${MINGW_PACKAGE_PREFIX}-${_realname}")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6-debug")
  options=('!strip')

  cp -rf ${srcdir}/${MSYSTEM}-debug${MINGW_PREFIX} "${pkgdir}"/
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
